/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.KategoryDokumen;
import com.portofolio.entity.vo.KategoryDokumenId;

@Lazy
@Repository
public interface KategoryDokumenDao extends CrudRepository<KategoryDokumen, KategoryDokumenId> {

    @Cacheable("KategoryDokumenDaofindOneBy")
    KategoryDokumen findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);
    

    @Query(QListAll)
    @Cacheable("KategoryDokumenDaoFindAllList")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.namaKategoryDokumen like %:namaKategoryDokumen% ")
    @Cacheable("KategoryDokumenDaoFindAllListPage")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaKategoryDokumen") String namaKategoryDokumen, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.id.kode like :kode")
    @Cacheable("KategoryDokumenDaoFindByKode")
    Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode, @Param("kdDepartemen") String kdDepartemen);
    
    
    
    String QListAll ="select new map(model.id.kdKategoryDokumen as kdKategoryDokumen,model.id.kdProfile as kdProfile "
            + ", model.namaKategoryDokumen as namaKategoryDokumen " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.kdDepartemen as kdDepartemen " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", departemen.namaDepartemen as namaDepartemen, model.version as version )" 
            + " from KategoryDokumen model left join model.id id left join model.departemen departemen where id.kdProfile=:kdProfile and departemen.id.kdProfile=id.kdProfile and model.kdDepartemen = :kdDepartemen ";


    @Query("select new map(model.id.kdKategoryDokumen as kdKategoryDokumen,model.id.kdProfile as kdProfile, model.namaKategoryDokumen as namaKategoryDokumen) "
    		+ " from KategoryDokumen model where model.id.kdProfile=:kdProfile and  model.statusEnabled = true")
	List<Map<String, Object>> findAllData(@Param("kdProfile") Integer kdProfile); 

}
